var View = function(){
    var _this = this;
    var prev_angle = undefined;
    var isRtl = NB.localization.getLocales().ui.isRtl;
    var openSettingsVisible = true;
    var categories = ["#hours","#minutes","#seconds"];
    var elements = {
        'big_container':$("#big_container"),
        'clock':{
            'clock':$("#clock"),
            'hands' : {
                'hour': $("#hour_hand"),
                'minute': $("#minute_hand"),
                'second': $("#second_hand")
            },
            'centre':$("#centre_dot"),
            'face':$("#clockimg")
        },
        'settings':{
            'wrapper':$("#settings_wrapper"),
            'close':$("#settings_close"),
            'button_grid':$("#button_grid"),
            'firstTimeHelperText':$("#firstTimeHelperText"),
        },
        'buttons':{
            'pauseButton': $("#pauseButton"),
            'resetButton':$("#resetButton"),
            'tfhourButton':$("#tfhourButton"),
            'hideShowButton':$("#hideShowButton"),
            'clockOptionButton':$("#clockOptionButton"),
            'clockOptionButton_analog':$("#clockOptionButton_analog"),
            'clockOptionButton_digital':$("#clockOptionButton_digital"),
            'clockOptionButton_analog_digital':$("#clockOptionButton_analog_digital")
        },
        'digitalclock':{
            'digitalclock':$("#digitalclock"),
            'hour':{
                'column':$(".hour_column"),
                'buffer':$("#hours_buffer"),
                'hours':$("#hours"),
                'input':$("#hoursinput")
            },
            'minute':{
                'column':$(".minute_column"),
                'buffer':$("#minutes_buffer"),
                'minutes':$("#minutes"),
                'input':$("#minutesinput")
            },
            'second':{
                'column':$(".second_column"),
                'buffer':$("#seconds_buffer"),
                'seconds':$("#seconds"),
                'input':$("#secondsinput"),
                'inc':$("#incsecond"),
                'dec':$("#decsecond"),
                'hide':$("#secondshide")
            },
            'timeinput':$("#timeinput"),
            'arrowImg':$(".arrowImg"),
            'inputField':$(".timeInputField"),
            'incButtons':$("#incButtons"),
            'decButtons':$("#decButtons"),
            'colon':$(".colon"),
            'ampm':{
                'ampm':$("#ampm"),
                'AM':$("#AM"),
                'PM':$("#PM"),
                'ampmTableRow':$("#ampm tr")
            },
            'container':$("#timeContainer"),
            'digitaltime':$("#digitaltime")
        }
    }
    _this.analogSettings = new SettingsButton('src/gear_icon.png');
    $('#clock').prepend(_this.analogSettings.jq);
    $('#clock').prepend($('#clock_handle'));
    _this.analogSettings.back.css({
        backgroundColor: '#00BFDD',
    });
    _this.digitalSettings = new SettingsButton('src/gear_icon.png');
    $('#digitalclock').prepend(_this.digitalSettings.jq);
    _this.digitalSettings.back.css({
        backgroundColor: '#00BFDD',
    });

    //rotates the given hand to the given degree
    function rotate(hand, degrees) {
        $(hand).css({
            '-webkit-transform': 'rotate(' + degrees + 'deg)',
            '-moz-transform': 'rotate(' + degrees + 'deg)',
            '-ms-transform': 'rotate(' + degrees + 'deg)',
            'transform': 'rotate(' + degrees + 'deg)'
        });
        if(hand.selector=="#minute_hand"){
            $(hand).css({
                'transform-origin': '50% 80%'
            });
        } else {
            $(hand).css({
                'transform-origin': '50% 75%'
            });
        }
        return;
    }
    this.updateAngle = function(event, date, selectedHand) {
        var date = new Date(date);
        var angle = this.getAngleFor(event);
        if (selectedHand) {
            convert(angle, date, selectedHand);
        }
        if(selectedHand === "second_hand") {
            prev_angle = date.getSeconds()*6;
        } else if(selectedHand === "minute_hand") {
            prev_angle = date.getMinutes()*6;
        } else if(selectedHand === "hour_hand") {
            prev_angle = (date.getHours()%12)*30;
        } else {
            prev_angle = angle;
        }
        return date;
    };
    this.getAngleFor = function(event) {
        var clock = $('#clock');
        var off = clock.offset();
        var x = event.pageX;
        var y = event.pageY;
        var dx = x - (off.left + clock.width() / 2);
        var dy = y - (off.top + clock.height() / 2);
        var angle = (Math.atan2(dy, dx) * 180 / Math.PI + 90) % 360;
        if(angle < 0) {
            angle += 360;
        }
        return angle;
    };
    //identifies the hand that is currently being dragged
    this.get_selectedHand = function(evt, date) {
        var id = evt.target.id;
        if (id === 'second_hand') {
            prev_angle = date.getSeconds()*6;
        } else if (id === 'minute_hand') {
            prev_angle = date.getMinutes()*6;
        } else if (id === "hour_hand") {
            prev_angle = (date.getHours()%12)*30;
        }
        return id;
    };
    //converts the angle after dragging a clock hand to the correct time and sets the date object to the new time.
    function convert(angle, date, selectedHand) {
        var hourString = 'hour_hand';
        var minuteString = 'minute_hand';
        var secondString = 'second_hand';
        if (selectedHand === hourString) {
            var prev_hours = date.getHours();
            var hours = (angle / 360) * 12;
            if (prev_hours >= 12) {
                hours += 12;
            }
            date.setHours(hours);
        } else if (selectedHand === minuteString) {
            date.setMinutes((angle / 360) * 60);
        } else if (selectedHand === secondString) {
            date.setSeconds((angle / 360) * 60);
        }
        if (prev_angle - angle > 250) {
            if (selectedHand === hourString) {
                if (prev_hours < 12) {
                    date.setHours(date.getHours() + 12);
                } else if (prev_hours > 12) {
                    date.setHours(date.getHours() - 12);
                }
            } else if (selectedHand === minuteString) {
                date.setHours(date.getHours() + 1);
            } else if (selectedHand === secondString) {
                date.setMinutes(date.getMinutes() + 1);
            }
        } else if (prev_angle - angle < (-250)) {
            if (selectedHand === hourString) {
                if (prev_hours < 12) {
                    date.setHours(date.getHours() + 12);
                } else if (prev_hours >= 12) {
                    date.setHours(date.getHours() - 12);
                }
            } else if (selectedHand === minuteString) {
                date.setHours(date.getHours() - 1);
            } else if (selectedHand === secondString) {
                date.setMinutes(date.getMinutes() - 1);
            }
        }
    }
    this.openSettings = function(firstTimeHelperTextTriggered, isAlreadyExpanded){
        if(!firstTimeHelperTextTriggered){
            elements.settings.firstTimeHelperText.show();
        }
        $("#incButtons, #decButtons").show();
        this.analogSettings.jq.hide();
        this.digitalSettings.jq.hide();
        _this.setOpenSettingsVisible(false);
        elements.settings.wrapper.addClass('settings_wrapper_settingsOpen');
        elements.settings.close.show();
        elements.settings.button_grid.show();

        $("#digitaltime, .timeInputField").css({
            background: 'white',
            color: 'black'
        });
    };
    this.closeSettings = function(firstTimeHelperTextTriggered, clockOption, isClockCounting){
        if(!firstTimeHelperTextTriggered){
            elements.settings.firstTimeHelperText.hide();
        }
        $("#incButtons, #decButtons").hide();
        this.analogSettings.jq.show();
        if (clockOption === "digital") {
            this.digitalSettings.jq.show();
        } else {
            this.digitalSettings.jq.hide();
        }
        _this.setOpenSettingsVisible(true);
        elements.settings.close.hide();
        elements.settings.wrapper.removeClass('settings_wrapper_settingsOpen');
        var settings_padding = (elements.settings.wrapper.width()-elements.big_container.width());
        elements.settings.button_grid.hide();

        $("#digitaltime, .timeInputField").css({
            background: 'transparent',
            color: 'white'
        });
    };
    //function called to resize elements
    this.resize = function(isSettingsOpen, tfhours) {
        var ratio = 1;
        if(isSettingsOpen){
            ratio = (elements.big_container.width())/449;
        } else {
            ratio = NB.getHostObject().width/449;
            _this.setOpenSettingsVisible(true);
        }
        if(isSettingsOpen){
            var b = 4 * ratio;
            if(b < 1) {
                b = 1;
            }
            $('.setting_button').css('border',b + "px solid white");
        }
        
        //Font Sizes
        $('#ampm').css('font-size', ratio * 24);
        var helper = $('#firstTimeHelperText');
        helper.css('font-size', ratio * 28);
        $('.setting_button').css('font-size', ratio * 24);
        $(".timeInputField, #digitaltime, .colon").css('font-size', ratio * 70);
        recenterTime(isSettingsOpen, tfhours);
    };
    this.layoutBig = function(settingsOpen) {
        var top = 0;
        var x = 0;
        if(settingsOpen) {
            top = '5%';
            x = '5%';
        }
        $('#big_container').css({
            top: 0,
            left: x,
            right: x,
            bottom: 0,
        });
        var btns = $('#button_grid');
        btns.height(0.48 * btns.width());
    };
    this.layoutAnalogClock = function(clockOption, helperText, settingsOpen) {
        var clock = $('#clock');
        var width = clock.width();
        clock.height(width);
        var top = 0;

        if(settingsOpen) {
            if(helperText) {
                top = "5%";
            } else {
                top = "20%";
            }
        } else {
            if(clockOption === "analog") {
                top = "1%";
            }
        }
        clock.css({
            top: top,
        });
        _this.analogSettings.layoutBehindCircle($('#clock').width());
    };
    this.layoutDigitalClock = function(clockOption, settingsOpen) {
        var digital = $('#digitalclock');
        var analogTop = $('#clock').position().top;
        var top = analogTop + $('#clock').height() * 1.05;
        var innerWidth = '100%';
        var height = digital.width() * 0.4;
        if(settingsOpen) {
            if(clockOption == "digital") {
                top = '14%';
            }
        } else {
            if(clockOption == "digital") {
                top = 0;
                height = $('#big_container').height();
                _this.digitalSettings.layoutBehindRect($('#big_container').height(), 0);
                innerWidth = digital.width() - 0.8 * _this.digitalSettings.jq.width();
            }
        }
        digital.css({
            top: top,
            height: height,
        });
        $('#timeContainer').width(innerWidth);
    };
    function recenterTime(isSettingsOpen, tfhours){
        //top positioning of colons
        elements.digitalclock.colon.css('top',elements.digitalclock.arrowImg.height());
        //width of inputs
        for (var x =0; x <categories.length; x++){
            $(categories[x]+"input").width($(categories[x]).width()+$(categories[x]+"_buffer").width());
        }
        //left buffer between ampm and digitaltime
        elements.digitalclock.ampm.ampm.css('margin-left',(elements.digitalclock.ampm.ampm.width())/4);
        //left coordinates of time (and ampm), depends on if 24-hour mode is on
        var ampmWidth = tfhours?0:elements.digitalclock.ampm.ampm.width()+parseFloat(elements.digitalclock.ampm.ampm.css('margin-left').substring(0,elements.digitalclock.ampm.ampm.css('margin-left').length-2));
        var digitaltimeMarginLeft = tfhours?(elements.digitalclock.container.width()-elements.digitalclock.digitaltime.width())/2:((elements.digitalclock.container.width()-(elements.digitalclock.digitaltime.width()-elements.digitalclock.hour.buffer.width()+ampmWidth))/2)-elements.digitalclock.hour.buffer.width();
        elements.digitalclock.digitaltime.css('margin-left',digitaltimeMarginLeft);
        //top coordinates of time and ampm
        elements.digitalclock.digitaltime.css('margin-top',((elements.digitalclock.container.height()-elements.digitalclock.digitaltime.height())/2)+elements.digitalclock.digitaltime.height()*0.08);
        elements.digitalclock.ampm.ampm.css('margin-top',((elements.digitalclock.container.height()-elements.digitalclock.digitaltime.height())/2)+elements.digitalclock.digitaltime.height()*0.08);
        //top coords of inc/dec buttons
        var timeInputHeight = isSettingsOpen ? elements.digitalclock.inputField.height()*1.15+parseFloat(elements.digitalclock.digitaltime.css('margin-top').substring(0,elements.digitalclock.digitaltime.css('margin-top').length-2))/2+elements.digitalclock.decButtons.height()/2 : "30%";
        // elements.digitalclock.decButtons.css('top',timeInputHeight);
        if (!isSettingsOpen) {
            _this.setOpenSettingsVisible(true);
        }
    }
    function startMode(string){
        $(string).show();
        $(string+'input').remove();
        $(string+"_buffer").show();
    }
    this.displayDropdown = function(option) {
        switch (option) {
            case "digital":
                elements.buttons.clockOptionButton_digital.hide();
                elements.buttons.clockOptionButton_analog_digital.show();
                elements.buttons.clockOptionButton_analog.show();
                break;
            case "analog_digital":
                elements.buttons.clockOptionButton_analog_digital.hide();
                elements.buttons.clockOptionButton_digital.show();
                elements.buttons.clockOptionButton_analog.show();
                break;
            case "analog":
            default:
                elements.buttons.clockOptionButton_analog.hide();
                elements.buttons.clockOptionButton_analog_digital.show();
                elements.buttons.clockOptionButton_digital.show();
                break;
        }
        $(".drop-main").show();
    };
    //updates the analog/digital/both display options of the clock
    this.update_clockView = function(option) {
        var ann = $('#dropdown_analog');
        var dig = $('#dropdown_digital');
        var annDig = $('#dropdown_analog_digital');
        ann.hide();
        dig.hide();
        annDig.hide();
        switch (option) {
            case "digital":
                elements.clock.clock.hide();
                elements.digitalclock.digitalclock.show();
                elements.buttons.tfhourButton.show();
                dig.show();
                break;
            case "analog_digital":
                elements.clock.clock.show();
                elements.digitalclock.digitalclock.show();
                elements.buttons.tfhourButton.show();
                annDig.show();
                break;
            default:
                elements.clock.clock.show();
                elements.digitalclock.digitalclock.hide();
                elements.buttons.tfhourButton.hide();
                ann.show();
                break;
        }
        $(".drop-main").hide();
    };
    //toggles the visibility ofthe seconds
    this.hideSeconds_View = function(hide_seconds) {
        if (hide_seconds) {
            elements.digitalclock.second.hide.hide();
            elements.digitalclock.second.inc.hide();
            elements.digitalclock.second.dec.hide();
            elements.clock.hands.second.hide();
            elements.buttons.hideShowButton.text(localizedStrings.showSeconds);
        } else {
            elements.digitalclock.second.hide.show();
            elements.digitalclock.second.inc.show();
            elements.digitalclock.second.dec.show();
            elements.clock.hands.second.show();
            elements.digitalclock.second.input.width(elements.digitalclock.second.seconds.width()+elements.digitalclock.second.buffer.width());
            elements.buttons.hideShowButton.text(localizedStrings.hideSeconds);
        }
        // recenterTime();
    };
    //switches clock between 12h and 24h
    this.tfhours_View = function(tfhours) {
        if (tfhours) {
            elements.digitalclock.ampm.ampmTableRow.hide();
            elements.buttons.tfhourButton.text(localizedStrings.hour12);
        } else {
            elements.digitalclock.ampm.ampmTableRow.show();
            elements.buttons.tfhourButton.text(localizedStrings.hour24);
        }
    };
    this.set_View = function(){
        elements.buttons.pauseButton.text(localizedStrings.start);
        for (var x =0; x <categories.length; x++){
            $(categories[x]+"input").width($(categories[x]).width()+$(categories[x]+"_buffer").width());
        }
        elements.digitalclock.hour.input.select();
    };
    this.start_View = function(tfhours){
        elements.buttons.pauseButton.text(localizedStrings.pause);
        if (!tfhours) {
            elements.digitalclock.ampm.ampmTableRow.show();
        } else 
            elements.digitalclock.ampm.ampmTableRow.hide();
        for (var x=0; x<categories.length; x++){
            startMode(categories[x]);
        }
    };
    this.setMode_View = function(id, time, tfhours){
        var input = $('<input />', {'type': 'text','class':'timeInputField '+id.substring(1,id.length)+'_column', 'id':id.substring(1,id.length)+"input"});
        $(id).after(input);
        var value = time;
        if(id!="#hours"){
            input.width($(id).width()+$(id+"_buffer").width());
            if(value <10){
                value = "0"+ value;
            }
        }else{
            if(!tfhours && value >12){
                value = value % 12;
            } else if(!tfhours && value ==0){
                value = 12;
            }
            if(tfhours && value < 10){
                value = "0" + value;
            }
            if(elements.digitalclock.hour.buffer.width()==0){
                input.width($(id).width()*2);
            }
        }
        $(input).val(value);
        $(id).hide();
        $(id+"_buffer").hide();
        return input;
    };
    this.toggleNoon_View = function(pastNoon){
        if(!pastNoon){
            $("#PM").addClass('active');
            $("#AM").removeClass('active');
        }else{
            $("#AM").addClass('active');
            $("#PM").removeClass('active');
        }
    };
    this.refreshInputVales = function(h, m, s){
        if (document.activeElement.id == "hoursinput" || $('#hoursinput').val().length == 2) {
                elements.digitalclock.hour.input.val(h);
                elements.digitalclock.hour.input.css('text-align','right');
        }
        if ((document.activeElement.id == "minutesinput" || ($('#minutesinput').val().length == 2 && $('#minutesinput').val().charAt(0) == '0')) && m < 10) {
            elements.digitalclock.minute.input.val("0" + m);
        } else if(elements.digitalclock.minute.input.val()!=""){
            elements.digitalclock.minute.input.val(m);
        }
        if ((document.activeElement.id == "secondsinput" || ($('#secondsinput').val().length == 2 && $('#secondsinput').val().charAt(0) == '0')) && s < 10) {
            elements.digitalclock.second.input.val("0" + s);
        } else if(elements.digitalclock.second.input.val()!=""){
            elements.digitalclock.second.input.val(s);
        }
    };
    this.localizeStrings = function(params){
        localize();
        if(params.keep_counting){
            elements.buttons.pauseButton.text(localizedStrings.pause);
        } else {
            elements.buttons.pauseButton.text(localizedStrings.start);
        }
        if(params.hide_seconds){
            elements.buttons.hideShowButton.text(localizedStrings.showSeconds);
        } else {
            elements.buttons.hideShowButton.text(localizedStrings.hideSeconds);
        }
        if(params.tfhours){
            elements.buttons.tfhourButton.text(localizedStrings.hour12);
        } else {
            elements.buttons.tfhourButton.text(localizedStrings.hour24);
        }
        elements.digitalclock.ampm.AM.text(localizedStrings.AM);
        elements.digitalclock.ampm.PM.text(localizedStrings.PM);
        elements.buttons.resetButton.text(localizedStrings.resetClock);
        elements.settings.firstTimeHelperText.text(localizedStrings.helperText);  
    };
    this.update_time_View = function (hours, minutes, seconds, noon, keep_counting, tfhours){
        rotate(elements.clock.hands.hour, ((360 / 12 * hours) + ((360 / 12) * (minutes / 60))) % 360);
        rotate(elements.clock.hands.minute, ((360 / 60 * minutes) + ((360 / 60) * (seconds / 60)) % 360));
        rotate(elements.clock.hands.second, (360 / 60 * seconds) % 360);

        if (hours < 10) {
            if (tfhours) {
                elements.digitalclock.hour.buffer.text("0");
            } else {
                elements.digitalclock.hour.buffer.html("&nbsp;&nbsp;");
            }
        } else elements.digitalclock.hour.buffer.text("");
        if (minutes < 10) {
            elements.digitalclock.minute.buffer.text(0);
        } else elements.digitalclock.minute.buffer.text("");
        if (seconds < 10) {
            elements.digitalclock.second.buffer.text(0);
        } else elements.digitalclock.second.buffer.text("");

        elements.digitalclock.hour.hours.text(hours);
        elements.digitalclock.minute.minutes.text(minutes);
        elements.digitalclock.second.seconds.text(seconds);
        if (noon == false) {
            elements.digitalclock.ampm.AM.addClass('active');
            elements.digitalclock.ampm.PM.removeClass('active');
        } else {
            elements.digitalclock.ampm.PM.addClass('active');
            elements.digitalclock.ampm.AM.removeClass('active');
        }
        if(!keep_counting){
            if (document.activeElement.id != "hoursinput" || $('#hoursinput').val().length == 2) {
                if (hours < 10 && tfhours) {
                    $("#hoursinput").val("0" + hours);
                } else {
                    $("#hoursinput").val(hours);
                    elements.digitalclock.hour.input.css('text-align','right');
                }

            }
            if ((document.activeElement.id != "minutesinput" || ($('#minutesinput').val().length == 2 && $('#minutesinput').val().charAt(0) == '0')) && minutes < 10) {
                $("#minutesinput").val("0" + minutes);
            } else if(elements.digitalclock.minute.input.val()!=""){
                $("#minutesinput").val(minutes);
            }
            if ((document.activeElement.id != "secondsinput" || ($('#secondsinput').val().length == 2 && $('#secondsinput').val().charAt(0) == '0')) && seconds < 10) {
                $("#secondsinput").val("0" + seconds);
            } else if($("#secondsinput").val()!=""){
                $("#secondsinput").val(seconds);
            }
        }
        elements.big_container.show();
    };
    this.setRtl = function(){
        if(isRtl){
           $("#hide").css('left','3%').css('right','');
           $("#hideShowButton").insertBefore($("#pauseButton"));
           $("#tfhourButton").insertBefore($("#resetButton"));
        }
    };
    this.getOpenSettingsVisible = function() {
        return openSettingsVisible;
    };
    this.setOpenSettingsVisible = function(visible) {
        openSettingsVisible = visible;
        if (visible) {
            _this.analogSettings.jq.show();
        }
    };
    
}